---
title: XMLSerializer
slug: Web/API/XMLSerializer
tags:
  - Converting
  - DOM Parsing
  - Interface
  - Parsing
  - Reference
  - Serialization
  - Serializing
  - XML
  - XMLSerializer
  - conversion
---
<div>{{APIRef("XMLSerializer")}}</div>

<p><span class="seoSummary">The <code>XMLSerializer</code> interface provides the {{domxref("XMLSerializer.serializeToString", "serializeToString()")}} method to construct an XML string representing a {{Glossary("DOM")}} tree.</span></p>

<h2 id="Methods">Methods</h2>

<dl>
	<dt id="serializeToString">{{domxref("XMLSerializer.serializeToString", "serializeToString()")}}</dt>
	<dd>Returns the serialized subtree of a string.</dd>
	<dt id="serializeToStream">{{domxref("XMLSerializer.serializeToStream", "serializeToStream()")}} {{ non-standard_inline }}{{ deprecated_inline }}</dt>
	<dd>The subtree rooted by the specified element is serialized to a byte stream using the character set specified.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Serializing_XML_into_a_string">Serializing XML into a string</h3>

<p>The first, basic, example just serializes an entire document into a string containing XML.</p>

<pre class="brush: js"> var s = new XMLSerializer();
 var d = document;
 var str = s.serializeToString(d);
 saveXML(str);</pre>

<p>This involves creating a new <code>XMLSerializer</code> object, then passing the {{domxref("Document")}} to be serialized into {{domxref("XMLSerializer.serializeToString", "serializeToString()")}}, which returns the XML equivalent of the document.</p>

<h3 id="Inserting_nodes_into_a_DOM_based_on_XML">Inserting nodes into a DOM based on XML</h3>

<p>This example uses the {{domxref("Element.insertAdjacentHTML()")}} method to insert a new DOM {{domxref("Node")}} into the body of the {{domxref("Document")}}, based on XML created by serializing an {{domxref("Element")}} object.</p>

<div class="note">
<p><strong>Note:</strong> In the real world, you should usually instead call {{domxref("Document.importNode", "importNode()")}} method to import the new node into the DOM, then call one of the following methods to add the node to the DOM tree:</p>

<ul>
	<li>The {{domxref("Document")}} and {{domxref("Element")}} methods {{domxref("ParentNode.append", "append()")}} and {{domxref("ParentNode.prepend", "prepend()")}}</li>
	<li>The {{domxref("ChildNode.replaceWith", "Node.replaceWith()")}} method (to replace an existing node with the new one)</li>
	<li>The {{domxref("Document.insertAdjacentElement()")}} and {{domxref("Element.insertAdjacentElement()")}} methods.</li>
</ul>
</div>

<p>Because <code>insertAdjacentHTML()</code> accepts a string and not a <code>Node</code> as its second parameter, <code>XMLSerializer</code> is used to first convert the node into a string.</p>

<pre class="brush: js">var inp = document.createElement('input');
var XMLS = new XMLSerializer();
var inp_xmls = XMLS.serializeToString(inp); // First convert DOM node into a string

// Insert the newly created node into the document's body
document.body.insertAdjacentHTML('afterbegin', inp_xmls);</pre>

<p>The code creates a new {{HTMLElement("input")}} element by calling {{domxref("Document.createElement()")}}, then serializes it into XML using {{domxref("XMLSerializer.serializeToString", "serializeToString()")}}.</p>

<p>Once that's done, <code>insertAdjacentHTML()</code> is used to insert the <code>&lt;input&gt;</code> element into the DOM.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('DOM Parsing', '#the-xmlserializer-interface', 'XMLSerializer')}}</td>
			<td>{{Spec2('DOM Parsing')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XMLSerializer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/Parsing_and_serializing_XML" title="en-US/Parsing_and_serializing_XML">Parsing and serializing XML</a></li>
	<li>{{domxref("XMLHttpRequest")}}</li>
	<li>{{domxref("DOMParser")}}</li>
</ul>
